<div class="full-height full-width flex-column" style="overflow: hidden">
  <div
    #panel
    class="full-height full-width grid-three-columns"
    style="overflow: hidden"
  >
    <div #statusChart [attr.data-test-element-id]="'status-chart'"></div>
    <div class="flex-column">
      <div class="flex-fixed-size m-l-auto m-t-15 font-18-px label-color">
        <b>{{
          'sqtm-core.campaign-workspace.campaign-page.statistics.charts.success-rate.title'
            | translate
        }}</b>
        <div
          [attr.data-test-icon-id]="'help-rate'"
          nz-icon
          nzType="sqtm-core-generic:help"
          nzTheme="outline"
          nz-tooltip
          [nzTooltipTitle]="rateTooltip"
          class="m-l-5"
        ></div>
      </div>
      <div #conclusivenessChartWrapper class="flex-row">
        <div
          #conclusivenessChart
          [attr.data-test-element-id]="'conclusiveness-chart'"
          class="chart"
        ></div>
        <div
          [style.width]="LEGEND_WIDTH + 'px'"
          #conclusivenessLegendWrapper
          class="legend_side"
        >
          <div>
            <div class="font-16-px label-color">
              <b>{{
                'sqtm-core.requirement-workspace.statistics.global-rates'
                  | translate
              }}</b>
            </div>
            <div
              class="global_rate success_color m-t-10"
              nz-tooltip
              [nzTooltipTitle]="
                'sqtm-core.entity.execution.status.SUCCESS' | translate
              "
              [nzTooltipPlacement]="'left'"
            >
              {{ calculateGlobalSuccessRate() }}%
            </div>
            <div
              class="global_rate failure_color m-t-10 m-b-50"
              nz-tooltip
              [nzTooltipTitle]="
                'sqtm-core.entity.execution.status.FAILURE' | translate
              "
              [nzTooltipPlacement]="'left'"
            >
              {{ calculateGlobalFailureRate() }}%
            </div>
          </div>
          <div>
            <ng-container
              *ngTemplateOutlet="
                criticalityLegend;
                context: {
                  label: TestCaseImportance.VERY_HIGH.i18nKey | translate,
                  radius: 7
                }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                criticalityLegend;
                context: {
                  label: TestCaseImportance.HIGH.i18nKey | translate,
                  radius: 6
                }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                criticalityLegend;
                context: {
                  label: TestCaseImportance.MEDIUM.i18nKey | translate,
                  radius: 5
                }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                criticalityLegend;
                context: {
                  label: TestCaseImportance.LOW.i18nKey | translate,
                  radius: 4
                }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                simpleLegend;
                context: {
                  label:
                    'sqtm-core.entity.execution.status.SUCCESS' | translate,
                  color: SUCCESS_COLOR
                }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                simpleLegend;
                context: {
                  label:
                    'sqtm-core.entity.execution.status.FAILURE' | translate,
                  color: FAILURE_COLOR
                }
              "
            ></ng-container>
          </div>
        </div>
      </div>
    </div>
    <div
      #importanceChart
      [attr.data-test-element-id]="'importance-chart'"
    ></div>
  </div>
</div>

<ng-template #criticalityLegend let-radius="radius" let-label="label">
  <div class="flex-row m-l-10">
    <div style="width: 20px; height: 20px" class="flex-fixed-size">
      <svg
        viewBox="0 0 20 20"
        fill="white"
        stroke="black"
        stroke-width="1"
        xmlns="http://www.w3.org/2000/svg"
      >
        <circle cx="10" cy="10" [attr.r]="radius" />
      </svg>
    </div>
    <span class="m-l-5">{{ label }}</span>
  </div>
</ng-template>

<ng-template #simpleLegend let-label="label" let-color="color">
  <div class="flex-row m-l-10">
    <div style="width: 20px; height: 20px" class="flex-fixed-size">
      <svg
        viewBox="0 0 20 20"
        [attr.fill]="color"
        stroke-width="1"
        xmlns="http://www.w3.org/2000/svg"
      >
        <rect x="4" y="4" width="12" height="12" />
      </svg>
    </div>
    <span class="m-l-5">{{ label }}</span>
  </div>
</ng-template>

<ng-template #rateTooltip>
  <span
    style="width: 600px"
    [innerHTML]="
      'sqtm-core.campaign-workspace.campaign-page.statistics.charts.success-rate.chart-text-description'
        | translate
    "
  ></span>
</ng-template>
